"use strict";
/**
 * Robin Coma Delperier
 * Licensed under the Apache-2.0 License
 * https://github.com/PlaceMe-SAS/single-spa-angular-cli/blob/master/LICENSE
 *
 * modified by Phodal HUANG
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var hashCode = function (str) {
    var hash = 0;
    if (str.length === 0) {
        return hash.toString();
    }
    for (var i = 0; i < str.length; i++) {
        hash = (hash << 5) - hash + str.charCodeAt(i);
        hash = hash & hash;
        hash = hash >>> 1;
    }
    return hash.toString();
};
var createScriptTag = function (src) {
    var script = document.createElement('script');
    script.type = 'text/javascript';
    script.src = src;
    script.charset = 'UTF-8';
    script.id = hashCode(src);
    return script;
};
var createLinkTag = function (src) {
    var link = document.createElement('link');
    link.rel = 'stylesheet';
    link.href = src;
    link.type = 'text/css';
    link.charset = 'UTF-8';
    link.id = hashCode(src);
    return link;
};
var assetsLoaderHelper = {
    hashCode: hashCode,
    createScriptTag: createScriptTag,
    createLinkTag: createLinkTag
};
exports.default = assetsLoaderHelper;
//# sourceMappingURL=assets-loader.helper.js.map