"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../model/constants");
var timeouts_1 = require("../helper/timeouts");
var app_helper_1 = require("../helper/app.helper");
var appsToUnload = {};
function toUnloadPromise(app, mooaInstance) {
    return __awaiter(this, void 0, void 0, function () {
        var unloadInfo, err_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    unloadInfo = appsToUnload[app.name];
                    if (app.status === constants_1.StatusEnum.NOT_LOADED) {
                        unloadingApp(app, unloadInfo);
                        return [2 /*return*/, app];
                    }
                    if (!(app.status === constants_1.StatusEnum.UNLOADING)) return [3 /*break*/, 2];
                    return [4 /*yield*/, unloadInfo.promise];
                case 1:
                    _a.sent();
                    return [2 /*return*/, app];
                case 2:
                    if (app.status !== constants_1.StatusEnum.NOT_MOUNTED) {
                        return [2 /*return*/, app];
                    }
                    if (!unloadInfo) {
                        return [2 /*return*/, app];
                    }
                    _a.label = 3;
                case 3:
                    _a.trys.push([3, 5, , 6]);
                    app.status = constants_1.StatusEnum.UNLOADING;
                    app_helper_1.mooaLog('Unloading application', app.name, app.status);
                    return [4 /*yield*/, timeouts_1.reasonableTime(app.unload(), "Unloading application '" + app.name + "'", app.timeouts.unload)];
                case 4:
                    _a.sent();
                    return [3 /*break*/, 6];
                case 5:
                    err_1 = _a.sent();
                    console.error('Unloading Error', err_1);
                    return [2 /*return*/, app];
                case 6:
                    unloadingApp(app, unloadInfo);
                    return [2 /*return*/, app];
            }
        });
    });
}
exports.toUnloadPromise = toUnloadPromise;
function unloadingApp(app, unloadInfo) {
    delete appsToUnload[app.name];
    delete app.bootstrap;
    delete app.mount;
    delete app.unmount;
    delete app.unload;
    app.status = constants_1.StatusEnum.NOT_LOADED;
    unloadInfo.resolve();
}
function getUnloadApps() {
    return appsToUnload;
}
exports.getUnloadApps = getUnloadApps;
function addAppToUnload(app, promiseGetter, resolve, reject) {
    appsToUnload[app.name] = { app: app, resolve: resolve, reject: reject };
    Object.defineProperty(appsToUnload[app.name], 'promise', {
        get: promiseGetter
    });
}
exports.addAppToUnload = addAppToUnload;
//# sourceMappingURL=unload.js.map