"use strict";
/**
 * Robin Coma Delperier
 * Licensed under the Apache-2.0 License
 * https://github.com/PlaceMe-SAS/single-spa-angular-cli/blob/master/LICENSE
 *
 * modified by Phodal HUANG
 *
 */
Object.defineProperty(exports, "__esModule", { value: true });
var MooaRouter = /** @class */ (function () {
    function MooaRouter() {
        this.defaultRoute = '';
        this.routes = [];
        this.lastPathName = '/';
    }
    MooaRouter.prototype.matchRoute = function (prefix, isDefaultPage) {
        var _this = this;
        this.routes.push(prefix);
        if (isDefaultPage) {
            this.defaultRoute = prefix;
        }
        return function (location) {
            if (prefix === '/') {
                return location.pathname === '/';
            }
            var route = _this.routes.find(function (r) { return _this.pathMatch(location, r); });
            if (route) {
                return _this.pathMatch(location, prefix);
            }
            else {
                _this.lastPathName = location.pathname;
                _this.navigate(_this.defaultRoute);
                return false;
            }
        };
    };
    MooaRouter.prototype.navigate = function (path) {
        history.pushState(null, '', path);
    };
    MooaRouter.prototype.pathMatch = function (location, path) {
        var loc = location.pathname + location.search;
        return loc.indexOf(path) !== -1;
    };
    return MooaRouter;
}());
exports.MooaRouter = MooaRouter;
exports.default = MooaRouter;
//# sourceMappingURL=router.js.map